using System;
using Syncfusion.Windows.Forms.Diagram;
using System.Runtime.Serialization;
using System.Collections;
using System.Windows.Forms;
using System.Drawing;

namespace Syncfusion.Windows.Forms.Diagram.Samples.OrgChart
{
	/// <summary>
	/// Summary description for ConditionSysbol.
	/// </summary>
	/// 
	[Serializable()]
	public class clsConditionSymbol:tmpSymbol
	{
		
		public RoundRect rect ;
		private Label lblDesc;
		private Label lblExpression;

		private const float DEFAULT_WIDTH=80;
		private const float DEFAULT_HEIGHT=20;
		//private const float DEFAULT_HEIGHT=25;

		//private const Color  COND_SYMBOL_COLOR=Color.AliceBlue; 
		//private const Color  HIGHLIGHT_SYMBOL_COLOR=Color.BurlyWood; 

		public enum FieldsEnum {Description=1,Expression,None};
		public clsConditionSymbol()
		{
		
			 
			this.rect = new RoundRect(0, 0, DEFAULT_WIDTH, DEFAULT_HEIGHT);
			this.rect.Name="Rectangle";
			this.rect.FillStyle.Color = Color.AliceBlue;
			//rect.Rotate(45F);

			this.AppendChild(this.rect);	
			this.lblDesc = this.AddLabel("", BoxPosition.Center);
			this.lblDesc.Name="lblDesc";
			this.lblDesc.FontStyle.Style = System.Drawing.FontStyle.Regular; //Bold;
			this.lblDesc.FontStyle.Family="Tahoma";
			this.lblDesc.FontStyle.Size=10F;
			//this.tskHome.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblDesc.BackgroundStyle.Color=System.Drawing.Color.Transparent;
			this.lblDesc.ReadOnly=true;
			this.lblDesc.HorizontalAlignment=System.Drawing.StringAlignment.Center;
			this.lblDesc.VerticalAlignment=System.Drawing.StringAlignment.Center;
			this.lblDesc.Width=this.Width;
			this.lblDesc.Height=this.Height;
			this.lblDesc.Visible=true;

			this.lblExpression = this.AddLabel("", BoxPosition.Center);
			this.lblExpression.Name="lblExpression";
			this.lblExpression.FontStyle.Style = System.Drawing.FontStyle.Regular; //Bold;
			this.lblExpression.FontStyle.Family="Tahoma";
			this.lblExpression.FontStyle.Size=8.25F;

			this.lblExpression.BackgroundStyle.Color=System.Drawing.Color.Transparent;
			this.lblExpression.ReadOnly=true;
			this.lblExpression.HorizontalAlignment=System.Drawing.StringAlignment.Center;
			this.lblExpression.VerticalAlignment=System.Drawing.StringAlignment.Center;
			this.lblExpression.Width=this.Width;
			this.lblExpression.Height=this.Height;
			this.lblExpression.Visible=false;

		}

		protected clsConditionSymbol(SerializationInfo info, StreamingContext context) : base(info, context)
		{

		}

		protected override void GetObjectData(SerializationInfo info, StreamingContext context)
		{
			base.GetObjectData(info, context);
		}


		protected override void OnDeserialization(object sender)
		{
			base.OnDeserialization(sender);

			// Get references to the child objects
			this.rect = this.GetChildByName("Rectangle") as Syncfusion.Windows.Forms.Diagram.RoundRect;
			this.lblDesc = this.GetChildByName("lblDesc") as Syncfusion.Windows.Forms.Diagram.Label;
			this.lblExpression = this.GetChildByName("lblExpression") as Syncfusion.Windows.Forms.Diagram.Label;
		}


	
		public string Description
		{
			set 
			{
				this.lblDesc.Text=value;
			}
			get {return this.lblDesc.Text;}
		}

		public string Expression
		{
			set 
			{
				this.lblExpression.Text=value;
			}
			get {return this.lblExpression.Text;}
		}
		public FieldsEnum TextField
		{
			set 
			{
				switch (value)
				{
					case FieldsEnum.Description:
						this.lblDesc.Visible=true;
						this.lblExpression.Visible=false;
						break;
					case FieldsEnum.Expression:
						this.lblDesc.Visible=false;
						this.lblExpression.Visible=true;
						break;
					case FieldsEnum.None:
						this.lblDesc.Visible=false;
						this.lblExpression.Visible=false;
						break;
					default:
						break;
				}
			}
			get 
			{
				if (this.lblDesc.Visible) return FieldsEnum.Description;
				else if (this.lblExpression.Visible) return FieldsEnum.Expression;
				else return FieldsEnum.None;
			}

		}
		protected override void OnMouseEnter(NodeMouseEventArgs evtArgs)
		{
			// TODO:  Add ConditionSysbol.OnMouseEnter implementation
			this.rect.FillStyle.Color = Color.BurlyWood;
			
		}
	
		protected override void OnMouseLeave(NodeMouseEventArgs evtArgs)
		{
			// TODO:  Add ConditionSysbol.OnMouseLeave implementation
			this.rect.FillStyle.Color = Color.AliceBlue;
		}
		protected override void OnBoundsChanged(BoundsEventArgs evtArgs)
		{
			this.lblDesc.Width=this.Width;
			this.lblDesc.Height=this.Height;
			this.lblExpression.Width=this.Width;
			this.lblExpression.Height=this.Height;

		}

		private const string YES_NO_LABEL_NAME="YesNo";
		private const string YES_VALUE="Yes";
		private const string NO_VALUE="No";
		public override bool AcceptConnection(Port sourcePort, Port targetPort)
		{
			bool accept = false;

			// First, determine which port belongs to the foreign port container.

			Port foreignPort = null;

			if (this.Ports.Contains(sourcePort) || this.CenterPort == sourcePort)
			{
				foreignPort = targetPort;
			}
			else if (this.Ports.Contains(targetPort) || this.CenterPort == targetPort)
			{
				foreignPort = sourcePort;
			}

			if (foreignPort == null)
			{
				return false;  // This should never happen
			}

			
			// Now get the foreign port container and check to see if it is
			// a Link object. If so, then check to see if the foreign port
			// is the link's tail port or head port. If it's the tail port,
			// then always allow the connection, because a member symbol can
			// have any number of edges leaving it. If it's the head port,
			// then only allow the connection if the member symbol has no
			// other edges entering it yet.

			IPortContainer foreignContainer = foreignPort.Container;
			if (foreignContainer != null)
			{
				Link link = foreignContainer as Link;
				if (link != null)
				{
					if (foreignPort == link.TailPort)
					{
						//accept = true;

						IGraphNode curNode = this as IGraphNode;

						if (curNode != null)
						{
							ICollection edgesLeaving = curNode.EdgesLeaving;
							if (edgesLeaving.Count < 2)
							{
								accept = true;

								//check Yes/No
								if (edgesLeaving.Count==1)
								{
									Link linkAnother=null;
									//????
									Model m=this.Root as Model;

									for (int i=0;i<m.Nodes.Count;i++)
									{
										Link linkTemp=m.GetChild(i) as Link;
										if (linkTemp!=null)
										{
											if (linkTemp.FromNode==this)
											{
												linkAnother=linkTemp;
												break;
											}
										}
									}
									if (linkAnother!=null)
									{
										Label lblAnother=linkAnother.GetChildByName(YES_NO_LABEL_NAME) as Label;
										
										Label lblYesNo=link.GetChildByName(YES_NO_LABEL_NAME) as Label;
									
										if ( lblAnother.Text==YES_VALUE)
										{
											lblYesNo.Text=NO_VALUE;
											lblYesNo.FillStyle.Color=System.Drawing.Color.BurlyWood;
											link.LineStyle.LineColor=Color.BurlyWood;
											link.FillStyle.Color=Color.BurlyWood;
										}
										else
										{
											lblYesNo.Text=YES_VALUE;  //default label
											lblYesNo.FillStyle.Color=System.Drawing.Color.LimeGreen;
											link.LineStyle.LineColor=Color.LimeGreen;
											link.FillStyle.Color=Color.LimeGreen;
										}
									}
								}

							}
							else
							{
								MessageBox.Show("A node can only have two children.");
							}
						}
					}
					else
					{
						IGraphNode curNode = this as IGraphNode;

						if (curNode != null)
						{
							ICollection edgesEntering = curNode.EdgesEntering;
							if (edgesEntering.Count == 0)
							{
								accept = true;
							}
							else
							{
								MessageBox.Show("Node only have one parent.");
							}
						}
					}
				}
			}

			return accept;
		}

	
	}
}
