using System;
using Syncfusion.Windows.Forms.Diagram;
using System.Runtime.Serialization;
using System.Collections;
using System.Drawing;

namespace Syncfusion.Windows.Forms.Diagram.Samples.OrgChart
{
	/// <summary>
	/// Summary description for tmpSymbol.
	/// </summary>
	[Serializable()]
	public class tmpSymbol:Symbol
	{
		
		//private const Color  COND_SYMBOL_COLOR=Color.AliceBlue; 
		//private const Color  HIGHLIGHT_SYMBOL_COLOR=Color.BurlyWood; 
		//private const Color  ALTER_SYMBOL_COLOR=Color.Beige; 
		//LINK_YES_COLOR=Color.LimeGreen
		//LINK_NO_COLOR=Color.BurlyWood

		public tmpSymbol()
		{
			
		}
		protected tmpSymbol(SerializationInfo info, StreamingContext context) : base(info, context)
		{

		}

		protected override void GetObjectData(SerializationInfo info, StreamingContext context)
		{
			base.GetObjectData(info, context);
		}

		protected override void OnDeserialization(object sender)
		{
			base.OnDeserialization(sender);
		}

		public int Rank
		{
			get
			{
				int rank = 1;

				IGraphNode thisNode = this as IGraphNode;
				IGraphNode curNode = thisNode;
				bool cyclicalPathFound = false;

				while (curNode != null && !cyclicalPathFound)
				{
					ICollection edgesEntering = curNode.EdgesEntering;
					if (edgesEntering.Count > 0)
					{
						IEnumerator enumEdgesEntering = edgesEntering.GetEnumerator();
						if (enumEdgesEntering != null)
						{
							enumEdgesEntering.MoveNext();
							IGraphEdge incomingEdge = enumEdgesEntering.Current as IGraphEdge;
							if (incomingEdge != null)
							{
								curNode = incomingEdge.FromNode;

								if (curNode == thisNode)
								{
									cyclicalPathFound = true;
								}
								else
								{
									rank++;
								}
							}
						}
					}
					else
					{
						curNode = null;
					}
				}

				return rank;
			}
		}


		public string Condition
		{
			get
			{
				int rank = 1;
				string sCond="";

				IGraphNode thisNode = this as IGraphNode;
				IGraphNode curNode = thisNode;
				bool cyclicalPathFound = false;

				while (curNode != null && !cyclicalPathFound)
				{
					ICollection edgesEntering = curNode.EdgesEntering;
					if (edgesEntering.Count > 0)
					{
						IEnumerator enumEdgesEntering = edgesEntering.GetEnumerator();
						if (enumEdgesEntering != null)
						{
							enumEdgesEntering.MoveNext();
							IGraphEdge incomingEdge = enumEdgesEntering.Current as IGraphEdge;
							
							if (incomingEdge != null)
							{
								curNode = incomingEdge.FromNode;
								
								clsConditionSymbol condSym = curNode as clsConditionSymbol;
								if (condSym!=null)
								{
									Link lnk=enumEdgesEntering.Current as Link;
									if (lnk!=null) 
									{
										Label lbl=(Label) lnk.GetChildByName("YesNo");
										if (lbl.Text=="Yes")
											sCond="("+condSym.Expression+") AND "+sCond ;
										else
											sCond="NOT ("+condSym.Expression+") AND "+sCond ;
									}
									
								}
								if (curNode == thisNode)
								{
									cyclicalPathFound = true;
								}
								else
								{
									
									rank++;
								}
								
							}
						}
					}
					else
					{
						curNode = null;
					}
				}
				if (sCond!="") sCond=sCond.Substring(0,sCond.Length-5);
				return sCond;
			}
		}

		//PathColor=null using default color
		//		COND_SYMBOL_COLOR=Color.AliceBlue; 
		//		private const Color  HIGHLIGHT_SYMBOL_COLOR=Color.BurlyWood; 
		//		private const Color  ALTER_SYMBOL_COLOR=Color.Beige; 
		public void SetPathColor(System.Drawing.Color PathColor)
		{
			   
				int rank = 1;
				string sCond="";
				clsAlternativeSymbol alterSymTmp=this as clsAlternativeSymbol;
				if (alterSymTmp!=null) 
				{
					
					alterSymTmp.rect.FillStyle.Color=PathColor;	
									
				}
				clsConditionSymbol condSymTmp=this as clsConditionSymbol;
				if (condSymTmp!=null) 
				{
					
					condSymTmp.rect.FillStyle.Color=PathColor;
									
				}

				IGraphNode thisNode = this as IGraphNode;
				IGraphNode curNode = thisNode;
				bool cyclicalPathFound = false;

				while (curNode != null && !cyclicalPathFound)
				{
					ICollection edgesEntering = curNode.EdgesEntering;
					if (edgesEntering.Count > 0)
					{
						IEnumerator enumEdgesEntering = edgesEntering.GetEnumerator();
						if (enumEdgesEntering != null)
						{
							enumEdgesEntering.MoveNext();
							IGraphEdge incomingEdge = enumEdgesEntering.Current as IGraphEdge;
							
							if (incomingEdge != null)
							{
								curNode = incomingEdge.FromNode;
								
								clsConditionSymbol condSym = curNode as clsConditionSymbol;
								if (condSym!=null)
								{
									
									condSym.rect.FillStyle.Color=PathColor;
									
									Link lnk=enumEdgesEntering.Current as Link;

									if (lnk!=null) 
									{
										lnk.FillStyle.Color=PathColor;
										lnk.LineStyle.LineColor=PathColor;
										Label lbl=(Label) lnk.GetChildByName("YesNo");
										lbl.FillStyle.Color=PathColor;
										if (lbl.Text=="Yes")
										{
											sCond="("+condSym.Expression+") AND "+sCond ;
										}
										else
										{
											sCond="NOT ("+condSym.Expression+") AND "+sCond ;
										}
									}
									
								}
								if (curNode == thisNode)
								{
									cyclicalPathFound = true;
								}
								else
								{
									
									rank++;
								}
								
							}
						}
					}
					else
					{
						curNode = null;
					}
				}
				if (sCond!="") sCond=sCond.Substring(0,sCond.Length-5);
		}


		public void ResetPathColor()
		{
			   
			int rank = 1;
			string sCond="";
			clsAlternativeSymbol alterSymTmp=this as clsAlternativeSymbol;
			if (alterSymTmp!=null) 
			{
				alterSymTmp.rect.FillStyle.Color=Color.Beige;					
			}
			clsConditionSymbol condSymTmp=this as clsConditionSymbol;
			if (condSymTmp!=null) 
			{
				condSymTmp.rect.FillStyle.Color=Color.AliceBlue;						
			}

			IGraphNode thisNode = this as IGraphNode;
			IGraphNode curNode = thisNode;
			bool cyclicalPathFound = false;

			while (curNode != null && !cyclicalPathFound)
			{
				ICollection edgesEntering = curNode.EdgesEntering;
				if (edgesEntering.Count > 0)
				{
					IEnumerator enumEdgesEntering = edgesEntering.GetEnumerator();
					if (enumEdgesEntering != null)
					{
						enumEdgesEntering.MoveNext();
						IGraphEdge incomingEdge = enumEdgesEntering.Current as IGraphEdge;
							
						if (incomingEdge != null)
						{
							curNode = incomingEdge.FromNode;
								
							clsConditionSymbol condSym = curNode as clsConditionSymbol;
							if (condSym!=null)
							{
									
								condSym.rect.FillStyle.Color=Color.AliceBlue;
										

								Link lnk=enumEdgesEntering.Current as Link;

								if (lnk!=null) 
								{
									Label lbl=(Label) lnk.GetChildByName("YesNo");
									if (lbl.Text=="Yes")
									{
										lnk.LineStyle.LineColor=Color.LimeGreen;
										lnk.FillStyle.Color=Color.LimeGreen;
										lbl.FillStyle.Color=Color.LimeGreen;

										sCond="("+condSym.Expression+") AND "+sCond ;
									}
									else
									{
										lnk.LineStyle.LineColor=Color.BurlyWood;
										lnk.FillStyle.Color=Color.BurlyWood;
										lbl.FillStyle.Color=Color.BurlyWood;
										sCond="NOT ("+condSym.Expression+") AND "+sCond ;
									}
								}
									
							}
							if (curNode == thisNode)
							{
								cyclicalPathFound = true;
							}
							else
							{
									
								rank++;
							}
								
						}
					}
				}
				else
				{
					curNode = null;
				}
			}
			if (sCond!="") sCond=sCond.Substring(0,sCond.Length-5);
		}

		public ICollection Employees
		{
			get
			{
				ArrayList employees = new ArrayList();

				IGraphNode thisNode = this as IGraphNode;

				if (thisNode != null)
				{
					ICollection edgesLeaving = thisNode.EdgesLeaving;
					if (edgesLeaving != null)
					{
						foreach (IGraphEdge curEdge in edgesLeaving)
						{
							tmpSymbol curEmployee = curEdge.ToNode as tmpSymbol;
							if (curEmployee != null)
							{
								employees.Add(curEmployee);
							}
						}
					}
				}

				return employees;
			}
		}
		public tmpSymbol Manager
		{
			get
			{
				tmpSymbol manager = null;
				IGraphNode thisNode = this as IGraphNode;
				IGraphNode fromNode;

				if (thisNode != null)
				{
					ICollection edgesEntering = thisNode.EdgesEntering;
					if (edgesEntering.Count > 0)
					{
						IEnumerator enumEdgesEntering = edgesEntering.GetEnumerator();
						if (enumEdgesEntering != null)
						{
							enumEdgesEntering.MoveNext();
							IGraphEdge incomingEdge = enumEdgesEntering.Current as IGraphEdge;
							if (incomingEdge != null)
							{
								fromNode = incomingEdge.FromNode;

								if (fromNode != null)
								{
									manager = fromNode as tmpSymbol;
								}
							}
						}
					}
				}

				return manager;
			}
		}


	}
}
